/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// DynamicGroupType the model 'DynamicGroupType'
type DynamicGroupType string

// List of DynamicGroupType
const (
	DYNAMICGROUPTYPE_STATIC       DynamicGroupType = "Static"
	DYNAMICGROUPTYPE_DYNAMIC      DynamicGroupType = "Dynamic"
	DYNAMICGROUPTYPE_FULL_DYNAMIC DynamicGroupType = "FullDynamic"
)

// All allowed values of DynamicGroupType enum
var AllowedDynamicGroupTypeEnumValues = []DynamicGroupType{
	"Static",
	"Dynamic",
	"FullDynamic",
}

func (v *DynamicGroupType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := DynamicGroupType(value)
	for _, existing := range AllowedDynamicGroupTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid DynamicGroupType", value)
}

// NewDynamicGroupTypeFromValue returns a pointer to a valid DynamicGroupType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewDynamicGroupTypeFromValue(v string) (*DynamicGroupType, error) {
	ev := DynamicGroupType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for DynamicGroupType: valid values are %v", v, AllowedDynamicGroupTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v DynamicGroupType) IsValid() bool {
	for _, existing := range AllowedDynamicGroupTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to DynamicGroupType value
func (v DynamicGroupType) Ptr() *DynamicGroupType {
	return &v
}

type NullableDynamicGroupType struct {
	value *DynamicGroupType
	isSet bool
}

func (v NullableDynamicGroupType) Get() *DynamicGroupType {
	return v.value
}

func (v *NullableDynamicGroupType) Set(val *DynamicGroupType) {
	v.value = val
	v.isSet = true
}

func (v NullableDynamicGroupType) IsSet() bool {
	return v.isSet
}

func (v *NullableDynamicGroupType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDynamicGroupType(val *DynamicGroupType) *NullableDynamicGroupType {
	return &NullableDynamicGroupType{value: val, isSet: true}
}

func (v NullableDynamicGroupType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDynamicGroupType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
